// Generated by CoffeeScript 1.7.1
(function() {
  var diff, ref2resource, respond, self_uri;

  diff = require('deep-diff').diff;

  respond = require('../responses');

  ref2resource = require('./dry').ref2resource;

  self_uri = require('./dry').self_uri;

  module.exports = function(Model, emitter, options) {
    return function(req, res) {
      return Model.findById(req.params._id, function(err, original_model) {
        if (err) {
          return respond.not_found(res, "" + Model.modelName + " with id " + req.params._id + " not found");
        }
        return Model.findByIdAndUpdate(req.params._id, req.body, function(err, new_model) {
          var difference;
          if (err) {
            return respond.not_acceptable(res, err.message);
          } else {
            if (options.refs != null) {
              ref2resource(new_model, options.refs);
            }
            difference = diff(original_model._doc, new_model._doc);
            emitter.emit('updated', JSON.stringify(difference));
            return respond.ok(res, new_model);
          }
        });
      });
    };
  };

}).call(this);
